note
   description: "PART that contains other parts"

deferred class COMPOSITE_PART
  inherit
    COMPOSITE [PART] -- Handles parent and children management features
    PART
      redefine make end

-----------------------------
feature {NONE} -- Initialization

make (the_name : STRING ; cost_to_retailer : REAL)
  -- Set the name and cost and discount for the PART.
  -- Create and initialize childrens.
  do
    Precursor(the_name, cost_to_retailer)
    create children.make
  end

-----------------------------
feature {PART_VISITOR} -- Commands

visit_children (visitor : PART_VISITOR)
  -- Makes visitor visit the current piece of equipment.
  do
    from  children.start
    until children.after
    loop
      children.item.accept(visitor)
      children.forth
    end
  end

invariant
	parent_child_link: parent /= Void implies parent.has(Current)

end
