note
   description: "Piece of electronic or computer equipment"

deferred class PART

-----------------------------
feature {NONE} -- Initialization

make (s : STRING; cost_to_retailer : REAL)
  require  s_not_void: s /= Void and cost_to_retailer > 0
  do
    name := s  ;  cost := cost_to_retailer
  end

-----------------------------
feature -- Attributes

name : STRING  -- Name of this equipment
cost : REAL    -- Cost to retailer of this piece of equipment
profit_margin : REAL = 1.25
		-- Amount to multiply cost to get net_price
		-- for this piece of equipment

-----------------------------
feature -- For Visitors

accept (visitor : PART_VISITOR) deferred end

invariant
   name_not_void: name /= Void
   positive_cost: cost > 0

end
