note
  description: "Visitor to display the names of pieces of computer equipment"

class INVENTORY_VISITOR
  inherit PART_VISITOR

create execute

-----------------------------
feature {NONE} -- Execution

execute(part : PART)
  -- Compute the price of the part
  do
  	create description.make(200)
    part.accept(Current)
  end

-----------------------------
feature {ANY} -- Queries

description : STRING -- Collected string of equipment description

-----------------------------
feature {ANY} -- Application

visit_bus (b : BUS)
  do
   description := description + "%N   - "
      b.visit_children(Current)
    description := description + "plugged into a " + b.name
  end

visit_cabinet (c : CABINET)
  do
    description := description + c.name + " containing "
      c.visit_children(Current)
    description := description + "%N"
  end

visit_card (c : CARD)
  do  description := description + c.name + ", "
  end

visit_chassis (c : CHASSIS)
  do
    description := description + "a " + c.name + " made of:"
      c.visit_children(Current)
  end

visit_DISK (fd : DISK)
  do
    description := description + "%N   - " + fd.name
  end

end
